(* Cyanide BBS Software 1990 *)
(* Written by MaggotMan and Cyanide Staff!   *)
(* Please don't distribute source, Or else.. *)

Program Cyanide;

{$R-        Range checking  Off            Don't change               }
{$S-        Stack checking  On             Makes code larger/slower   }
{$I-          I/O checking  Off            Don't change               }
{$D+     Debug information  On             Helps finding bugs         }
{$F+       Force far calls  On             Required for Overlaying    }
{$V-   Var-string checking  Relaxed        Don't change               }
{$B-    Boolean evaluation  Short Cicuit   Don't change               }
{$N-    Numeric processing  Software       Change if you have an 8087 }
{$O+      Overlay checking  On             Don't change               }
{$M 34000,0,0   Stack/heap  64k/none       Don't change               }
{$DEFINE OVERLAY}

Uses
  {$IFDEF OVERLAY}
  Initovr,  { Overlay Initialization }
  {$ENDIF}
  Crt,      { Turbo Pascal 5.5 Crt library }
  Dos,      { Turbo Pascal 5.5 Dos library }
  Printer,  { Turbo Pascal 5.5 Printer library }
  {$IFDEF OVERLAY}
  Overlay,  { Turbo Pascal 5.5 Overlay library }
  {$ENDIF}


  Main,     { Main Menu Base                              }
  Gentypes, { All Constant declarations and types         }
  Configrt, { Configuration Procedures and Declarations   }
  Modem,    { Modem Support                               }
  Statret,  { System Status declarations / procedures     }
  Gensubs,  { General subroutines                         }
  Subs1,    { Subroutine Library: I                       }
  Windows,  { Split Screen Routines                       }
  Subs2,    { Subroutine Library: ][                      }
  Textret,  { Message Base Routines                       }
  Mailret,  { E-Mail routines                             }
  Userret,  { User routines                               }
  Flags,    { Access Flag Routines                        }
  Mainr1,   { High-level Routines: I                      }
  Ansiedit, { ANSI Full-Screen Editor                     }
  Lineedit, { Message ASCii Editor                        }
  PullChat, { Ansi Pull-Down Menus and Chat Mode Routines }
  Mainr2,   { High-level Routines: ][                     }
  Overret1, { High-level Routines: ]I[                    }
  Subs3,    { Subroutine Library: ]I[                     }

  about,    {  About this BBS Section }
  Msgbase,  {        Bulletin Section }
  Configur, {   Configuration Section }
  Newkfg,   {  Newuser Config Section }
  Database, {        Database Section }
  Doors,    {            Door Section }
  Email,    {          E-Mail Section }
  Filexfer, {   File Transfer Section }
  Voting,   {          Voting Section }
  Userstuf, {  User Utilities Section }
  Gfiles,   {         G-Files Section }
  Viewansi, {  Screen Viewing Section }
  Rumorz,   {   Random Rumors Section }
  Trivia,   {          Trivia Section }
  Timebank, {        TimeBank Section }

  Mainmenu, { Main menu commands      }
  Waitcall, { Waiting for calls       }
  Getlogin, { Log-in procedure        }
  Init;     { Initialization routines }

{$IFDEF OVERLAY}
{$O About}
{$O Msgbase}    (* Cyanide's Overlay Files *)
{$O Configur}
{$O Newkfg}
{$O Database}
{$O Doors}
{$O Email}
{$O Filexfer}
{$O Gfiles}
{$O Viewansi}
{$O Voting}
{$O Waitcall}
{$O Getlogin}
{$O Init}
{$O Rumorz}
{$O Subs3}
{$O Trivia}
{$O Timebank}
{$ENDIF}

var gototerm:boolean;
    q          :integer;
    choicez    :mstr;

begin
  checkbreak:=false;
  readconfig;
  validconfiguration;
  initboard (true);
  fromdoor:=paramcount>=3;
  repeat
    gototerm:=false;
    returnfromdoor;
    if not fromdoor then begin
      gototerm:=waitforacall;
      if gototerm then else getloginproc
    end;
    if not gototerm then begin
      votingbooth (true);
      begin
       repeat
        if fromdoor and (returnto='D') then doorsmenu;
        cursection:=mainsysop;
        randomrumor;
        echoit:=true;
	q:=menu ('Main Menu','MAIN','ABCDEFGHIKLMNOPQRSTUVWXYZ+-!&%@=*^$');
        writeln;
        case q of
          1:aboutthisbbs;
          2:bbslist;
          3:summonsysop;
          4:datamenu;
          5:emailmenu;
          6:feedback;
          7:logoff;
          8:mainhelp;
          9:begin
             writeln;
             writestr ('Which Info-Form would you like to fill out [#1-5]? *');
             if (valu(input)>0) or (valu(input)<6) then
              infoform (valu(input)) else
             writeln (^M'Invalid Info-Form Number!'^M);
            end;
          10:configure;
          11:listusers;
          12:bulletinmenu;
          13:printnews;
          14:doorsmenu;
          15:gfilesection;
          16:write (^M+'Sorry, Emergency Chat is Not Yet Implemented.'+^M);
          17:rumormenu;
          18:showsystemstatus;
          19:udsection;
          20:playTrivia;
          21:votingbooth(false);
          22:showlastcallers;
          23:transfername;
          24:allstatus;
          25:setlastcall;
          26:changepwd;
          27:write (^M+'If you want your name changed then leave [F]eedback to the Sysop.'+^M);
          28:requestraise;
          29:donations;
          30:mainsysopcommands;
          31:setmenutype;
	  32:viewansiscreens;
	  33:showcredits;
          34:timebankmenu
        end
      until hungupon
      end;
      fromdoor:=false;
      if not disconnected then disconnect;
      ensureclosed;
      clrscr;
      if sysnext then begin
        dontanswer;
        halt (4)
      end;
      initboard (false)
    end
  until not gototerm;
  dontanswer;
  halt (0)
end.
